/*
    MonitorIT - A network monitoring tool
    Copyright (C) 2000-2001 Alvaro Lopes <alvieboy@alvie.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __GTKTEXT_H__
#define __GTKTEXT_H__
 /*
#include "Visual.h"

#include "Text.h"

*/
#include <gtk--/drawingarea.h>
#include "GTKWidget.h"
#include "DString.h"

class GTKInterface;

class GTKText: public GTKWidget, public Gtk::DrawingArea
{
public:
    GTKText(GTKInterface &v);
    //~GTKText();
    //virtual void DrawAt(int x,int y);
    //void RedrawAll(int x,int y);// { GTKWidget::RedrawAll(x,y); }
    virtual void Redraw() { draw(FALSE); }
    void SetFont(const char*);
    void SetText(const char*);
    //void SetOrigin(int x,int y);
    void SetSize(int w, int h);
    //void SetClipping(int width, int height);
    void SetColor(const char *color);
    void SetBGColor(const char *color);

    void Scroll();
    void AllScroll(void);

    void SetXBorder(int b) { xborder=b; }
    void SetYBorder(int b) { yborder=b; }

    void SetTemporaryTextNoScroll(const char *text);
    void CancelTemporary();

    virtual int Width() { return w_; }
    virtual int Height() { return h_; }
    virtual void set_usize(int w,int h) {
	w_=w;
	h_=h;
	Gtk::DrawingArea::set_usize(w,h);
    }

private:
    void DrawText(const dstring &);
    virtual int expose_event_impl(GdkEventExpose*);
    void NextText();
    /*Pixmap renderarea;
    int pixmap_width, pixmap_height;
     */
    int textistemp;
    int text_yasc, text_xasc;
    int h_,w_;
    dstring text,nexttext,temptext;
    Gdk_Font font;
    Gdk_Color color,bgcolor;
    int tw,th;
    int xoffset;
    int xborder, yborder;
    Gdk_Pixmap render;
    Gdk_GC gc;
};


#endif
